diff --git a/src/ui-arena.c b/src/ui-arena.c
index e2cea1e..a6329b0 100644
--- a/src/ui-arena.c
+++ b/src/ui-arena.c
@@ -18,7 +18,9 @@
 
 #include "ui-arena.h"
 
-#include "xpm/statusbar.xpm"
+#include "configs.h"
+#include "map.h"
+
 #include "xpm/space.xpm"
 #include "xpm/food.xpm"
 #include "xpm/wall.xpm"
@@ -30,468 +32,469 @@
 #include "xpm/robot_west.xpm"
 #include "xpm/robot.xpm"
 
-#include "map.h"
-#include "configs.h"
-
 #include <stdlib.h>
-
-#include <glib/gprintf.h>
-
-#include "grobot.h"
-extern GRobot *robot;
+#include <glib.h>
 
 #define TILE_SIZE	16
 
-enum
+enum conn_signals
 {
-	ARG_0,
-	ARG_MAP
+	MAP_UPDATE,
+	MAP_MOVE,
+	LAST_CONN_SIGNAL
 };
 
-struct _UIArenaPrivate
+enum tile_index
 {
-	Map *map;
-	MapSize *map_size;
-
-	GdkPixmap *buf;
-	GdkFont *font;
-
-	int width;
-	int height;
-
-	GdkPixmap *win_bufi;
-	GdkPixmap *statusbar;
-	GdkPixmap *space;
-	GdkPixmap *food;
-	GdkPixmap *wall;
-	GdkPixmap *prize;
-	GdkPixmap *baddie;
-	GdkPixmap *robotDirs[4];
-	GdkPixmap *robotPix;
+ TILE_SPACE,
+ TILE_FOOD,
+ TILE_WALL,
+ TILE_PRIZE,
+ TILE_BADDIE,
+ TILE_ROBOT_NORTH,
+ TILE_ROBOT_SOUTH,
+ TILE_ROBOT_EAST,
+ TILE_ROBOT_WEST,
+ TILE_ROBOT,
+ TILE_LAST
 };
 
-#define UI_ARENA_GET_PRIVATE(obj) \
-    G_TYPE_INSTANCE_GET_PRIVATE(obj, UI_TYPE_ARENA, UIArenaPrivate)
+static GdkPixbuf* tile_buf[TILE_LAST] = { 0 };
 
-G_DEFINE_TYPE(UIArena, ui_arena, GTK_TYPE_DRAWING_AREA)
+static char** xpm[TILE_LAST] = \
+  {space_xpm, food_xpm, wall_xpm, prize_xpm, baddie_xpm,
+   robot_north_xpm, robot_south_xpm, robot_east_xpm,
+   robot_west_xpm, robot_xpm};
 
-static gboolean ui_arena_expose(GtkWidget *widget, GdkEventExpose *event,
-	UIArena *arena);
-static gboolean ui_arena_configure(GtkWidget *widget,
-	GdkEventConfigure *event, UIArena *arena);
-static void create_image (UIArena *arena, gchar **data, GdkPixmap **image);
-static void put_tile(UIArena *arena, GdkPixmap *image, gint x, gint y);
-
-GtkWidget *ui_arena_new()
+struct _UIArenaAnimate
 {
-	return GTK_WIDGET(g_object_new(UI_TYPE_ARENA, NULL));
-}
-
-static void ui_arena_init(UIArena *arena)
-{
-	arena->priv = UI_ARENA_GET_PRIVATE(arena);
-
-	arena->priv->map = NULL;
-	arena->priv->map_size = NULL;
-	arena->priv->width = 400;
-	arena->priv->height = 200;
-	arena->priv->font = gdk_font_from_description(
-		pango_font_description_from_string("Fixed 18"));
-
-	gtk_widget_set_size_request(GTK_WIDGET(arena), arena->priv->width,
-		arena->priv->height);
-
-	g_signal_connect(G_OBJECT(arena), "expose_event",
-		G_CALLBACK(ui_arena_expose), arena);
-	g_signal_connect(G_OBJECT(arena), "configure_event",
-		G_CALLBACK(ui_arena_configure), arena);
-
-	gtk_widget_set_events(GTK_WIDGET(arena),
-		GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK);
-}
+  cairo_surface_t *surface;
+  UIArena *arena;
+  gint from_x;
+  gint from_y;
+  gint to_x;
+  gint to_y;
+  gint x_delta;
+  gint y_delta;
+  gint tile;
+  gint movement;
+
+  gint max_iteration;
+  gint iteration;
+};
 
-static void ui_arena_class_init(UIArenaClass *klass)
-{
-	g_type_class_add_private(G_OBJECT_CLASS(klass),
-		sizeof(UIArenaPrivate));
-}
+typedef struct _UIArenaAnimate UIArenaAnimate;
 
-static gboolean ui_arena_expose(GtkWidget *widget, GdkEventExpose *event,
-	UIArena *arena)
+struct _UIArenaPrivate
 {
-	gdk_draw_drawable(widget->window,
-		widget->style->fg_gc[GTK_WIDGET_STATE(widget)], arena->priv->buf,
-		event->area.x, event->area.y, event->area.x, event->area.y,
-		event->area.width, event->area.height);
-
-	if(arena->priv->map)
-	{
-		gdk_draw_rectangle(widget->window, widget->style->black_gc, FALSE,
-			0, 0, widget->allocation.width - 2,
-			widget->allocation.height - 1);
-	}
+  cairo_surface_t *surface;
+  GtkDrawingArea *arena;
+  GtkLabel *filelabel;
 
-	return FALSE;
-}
+  Map *map;
 
-static gboolean ui_arena_configure(GtkWidget *widget,
-	GdkEventConfigure *event, UIArena *arena)
-{
-	if(arena->priv->buf)
-		g_object_unref(arena->priv->buf);
+  int width;
+  int height;
 
-	arena->priv->buf = gdk_pixmap_new(widget->window,
-		widget->allocation.width - 1, widget->allocation.height, -1);
+  GAsyncQueue *animation_queue;
 
-	gdk_draw_rectangle(arena->priv->buf, widget->style->white_gc, TRUE,
-		0, 0, widget->allocation.width, widget->allocation.height);
+  gulong connected_signals[LAST_CONN_SIGNAL];
+};
 
-	return TRUE;
-}
+G_DEFINE_TYPE_WITH_CODE(UIArena, ui_arena, GTK_TYPE_BOX, G_ADD_PRIVATE(UIArena))
 
-void ui_arena_set_map(UIArena *arena, Map *map)
+static gboolean
+ui_arena_draw_handler(GtkWidget *widget, cairo_t *cr, UIArena *uiarena)
 {
-	arena->priv->map = map;
-
-	g_object_get(G_OBJECT(arena->priv->map), "size",
-		&arena->priv->map_size, NULL);
+  cairo_set_source_surface(cr, uiarena->priv->surface, 0, 0);
+  cairo_paint(cr);
 
-	arena->priv->width = arena->priv->map_size->num_cols * TILE_SIZE;
-	arena->priv->height = arena->priv->map_size->num_rows * TILE_SIZE + 32;
-
-	gtk_widget_set_size_request(GTK_WIDGET(arena), arena->priv->width,
-		arena->priv->height);
+  return FALSE;
 }
 
-void ui_arena_draw(UIArena *arena)
+static void
+ui_arena_init(UIArena *self)
 {
-	gint i, j;
-
-	if(!arena->priv->map)
-		return;
-
-	for (j = 0; j < arena->priv->map_size->num_rows; j++)
-	{
-		for (i = 0; i < arena->priv->map_size->num_cols; i++)
-		{
-			switch(MAP_GET_OBJECT(arena->priv->map, i, j))
-			{
-			case '\0':
-				put_tile(arena, arena->priv->wall, i * TILE_SIZE,
-					j * TILE_SIZE);
-				break;
-			case SPACE:
-				put_tile(arena, arena->priv->space, i * TILE_SIZE,
-					j * TILE_SIZE);
-				break;
-			case FOOD:
-				put_tile(arena, arena->priv->food, i * TILE_SIZE,
-					j * TILE_SIZE);
-				break;
-			case PRIZE:
-				put_tile(arena, arena->priv->prize, i * TILE_SIZE,
-					j * TILE_SIZE);
-				break;
-			case WALL:
-				put_tile(arena, arena->priv->wall, i * TILE_SIZE,
-					j * TILE_SIZE);
-				break;
-			case BADDIE:
-				put_tile(arena, arena->priv->baddie, i * TILE_SIZE,
-					j * TILE_SIZE);
-				break;
-			case ROBOT:
-				put_tile(arena, arena->priv->robotDirs[robot->dir], i * TILE_SIZE,
-					j * TILE_SIZE);
-				break;
-			default:
-				put_tile(arena, arena->priv->wall, i * TILE_SIZE,
-					j * TILE_SIZE);
-				break;
-			}
-		}
-	}
-
-	gtk_widget_queue_draw_area(GTK_WIDGET(arena), 0, 0, arena->priv->width,
-		arena->priv->height);
+  gtk_orientable_set_orientation(GTK_ORIENTABLE(self),
+				 GTK_ORIENTATION_VERTICAL);
+
+  self->priv = ui_arena_get_instance_private(self);
+
+  self->priv->map = NULL;
+  self->priv->width = TILE_SIZE * DEFAULT_MAP_COLUMNS;
+  self->priv->height = TILE_SIZE * DEFAULT_MAP_ROWS;
+
+  self->priv->animation_queue = g_async_queue_new_full(g_free);
+
+  /* Set Up the Graphical Map Display */
+  self->priv->arena = GTK_DRAWING_AREA(gtk_drawing_area_new());
+  gtk_widget_set_size_request(GTK_WIDGET(self->priv->arena),
+			      self->priv->width,
+			      self->priv->height);
+  self->priv->surface = cairo_image_surface_create
+    (CAIRO_FORMAT_ARGB32,
+     self->priv->width,
+     self->priv->height);
+
+  g_signal_connect(G_OBJECT(self->priv->arena), "draw",
+		   G_CALLBACK(ui_arena_draw_handler), self);
+
+  gtk_widget_set_events(GTK_WIDGET(self->priv->arena),
+			GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK);
+
+  /* Set up the Map File Name Display */
+  GtkWidget* head = gtk_grid_new();
+  gtk_grid_set_column_homogeneous(GTK_GRID(head), FALSE);
+  gtk_grid_set_column_spacing(GTK_GRID(head), 10);
+  self->priv->filelabel = GTK_LABEL(gtk_label_new("No map loaded."));
+  gtk_label_set_justify(self->priv->filelabel, GTK_JUSTIFY_LEFT);
+  gtk_label_set_selectable(self->priv->filelabel, TRUE);
+  GtkWidget* lab = GTK_WIDGET(gtk_label_new("Map"));
+  gtk_grid_attach(GTK_GRID(head), lab, 0, 0, 1, 1);
+  gtk_grid_attach(GTK_GRID(head), GTK_WIDGET(self->priv->filelabel), 1, 0, 1, 1);
+
+  /* Add the Graphical Map and File Label to UIArean */
+  gtk_box_set_homogeneous(GTK_BOX(self), FALSE);
+  gtk_box_pack_start(GTK_BOX(self), head, FALSE, TRUE, 0);
+  gtk_box_pack_start(GTK_BOX(self), GTK_WIDGET(self->priv->arena), TRUE, TRUE, 0);
+  gtk_widget_show(GTK_WIDGET(self->priv->arena));
+  gtk_widget_show(lab);
+  gtk_widget_show(GTK_WIDGET(self->priv->filelabel));
+  gtk_widget_show(head);
 }
 
-void ui_arena_postinit(UIArena *arena)
+static void
+ui_arena_class_init(UIArenaClass *klass)
 {
-	create_image(arena, statusbar_xpm, &arena->priv->statusbar);
-	create_image(arena, space_xpm, &arena->priv->space);
-	create_image(arena, food_xpm, &arena->priv->food);
-	create_image(arena, wall_xpm, &arena->priv->wall);
-	create_image(arena, prize_xpm, &arena->priv->prize);
-	create_image(arena, baddie_xpm, &arena->priv->baddie);
-	create_image(arena, robot_north_xpm, &arena->priv->robotDirs[0]);
-	create_image(arena, robot_east_xpm, &arena->priv->robotDirs[1]);
-	create_image(arena, robot_south_xpm, &arena->priv->robotDirs[2]);
-	create_image(arena, robot_west_xpm, &arena->priv->robotDirs[3]);
-	create_image(arena, robot_xpm, &arena->priv->robotPix);
+  for(gint i = 0; i < TILE_LAST; i++)
+    {
+      tile_buf[i] = gdk_pixbuf_new_from_xpm_data((const gchar **)xpm[i]);
+      if(gdk_pixbuf_get_width(tile_buf[i]) != TILE_SIZE ||
+	 gdk_pixbuf_get_height(tile_buf[i]) != TILE_SIZE)
+	g_warning("ui_arena_class_init: tile %d has width %d; height %d. Expected %d",
+		  i,
+		  gdk_pixbuf_get_width(tile_buf[i]),
+		  gdk_pixbuf_get_height(tile_buf[i]),
+		  TILE_SIZE);
+    }
 }
 
-static void create_image (UIArena *arena, gchar **data, GdkPixmap **image)
+static void
+ui_arena_draw_tile(cairo_t *cr, GdkPixbuf *tile, gint x, gint y)
 {
-	*image = gdk_pixmap_create_from_xpm_d(GDK_DRAWABLE(arena->priv->buf),
-		NULL, NULL, data);
-	if (*image == NULL)
-		g_fprintf (stderr, "Cannot create image from xpm\n");
+  gdk_cairo_set_source_pixbuf (cr, tile, x, y);
+  cairo_rectangle(cr, x, y,
+		  TILE_SIZE, TILE_SIZE);
+  cairo_fill(cr);
 }
 
-static void put_tile(UIArena *arena, GdkPixmap *image, gint x, gint y)
+Map *
+ui_arena_get_map(UIArena *self)
 {
-	gdk_draw_drawable(arena->priv->buf,
-		GTK_WIDGET(arena)->style->fg_gc[GTK_WIDGET_STATE(arena)],
-		GDK_DRAWABLE(image), 0, 0, x, y, TILE_SIZE, TILE_SIZE);
+  g_return_val_if_fail(IS_UI_ARENA(self), NULL);
+  
+  return(self->priv->map);
 }
 
-void ui_arena_update_status(UIArena *arena, const gchar *fmt, const gchar *thing,
-	glong energy, glong score, glong shields)
+static gint
+ui_arena_get_loc_tile_index(UIArena *self, gint x, gint y)
 {
-	gchar status[20];
-	gint x = 0;
-	gchar *s = NULL;
-
-	while(x < arena->priv->width)
+  gint retval = TILE_WALL;
+  switch(map_get_loc_thing_char(self->priv->map, x, y))
+    {
+    case SPACE:
+      retval = TILE_SPACE;
+      break;
+    case FOOD:
+      retval = TILE_FOOD;
+      break;
+    case PRIZE:
+      retval = TILE_PRIZE;
+      break;
+    case WALL:
+      retval = TILE_WALL;
+      break;
+    case BADDIE:
+      retval = TILE_BADDIE;
+      break;
+    case ROBOT:
+      switch(map_get_thing_orientation(self->priv->map, x, y))
 	{
-		gdk_draw_drawable(arena->priv->buf,
-			GTK_WIDGET(arena)->style->white_gc,
-			arena->priv->statusbar, 0, 0, x,
-			arena->priv->map_size->num_rows * TILE_SIZE, 96, 32);
-		x += 96;
-	}
-
-	s = g_strdup_printf(fmt, thing);
-	gdk_draw_string(arena->priv->buf, arena->priv->font,
-		GTK_WIDGET(arena)->style->white_gc, 3,
-		arena->priv->map_size->num_rows * TILE_SIZE + 16, s);
-	g_free(s);
-
-	if(energy > -1)
-	{
-		g_sprintf(status, "Robot Energy: %3ld", energy);
-		gdk_draw_string(arena->priv->buf, arena->priv->font,
-			GTK_WIDGET(arena)->style->white_gc, 240,
-			arena->priv->map_size->num_rows * TILE_SIZE + 12, status);
-	}
-
-	if (score > -1)
-	{
-		g_sprintf (status, "Robot Score: %3ld", score);
-		gdk_draw_string(arena->priv->buf, arena->priv->font,
-			GTK_WIDGET(arena)->style->white_gc, 240,
-			arena->priv->map_size->num_rows * TILE_SIZE + 25, status);
-	}
-
-	if (shields > -1)
-	{
-		g_sprintf (status, "Robot Shields: %3ld", shields);
-		gdk_draw_string(arena->priv->buf, arena->priv->font,
-			GTK_WIDGET(arena)->style->white_gc, 480,
-			arena->priv->map_size->num_rows * TILE_SIZE + 12, status);
+	case NORTH:
+	  retval = TILE_ROBOT_NORTH;
+	  break;
+	case SOUTH:
+	  retval = TILE_ROBOT_SOUTH;
+	  break;
+	case EAST:
+	  retval = TILE_ROBOT_EAST;
+	  break;
+	case WEST:
+	  retval = TILE_ROBOT_WEST;
+	  break;
+	default:
+	  retval = TILE_ROBOT;
+	  g_warning("ui_arena_get_loc_tile_index: unexpected robot dir %d",
+		    map_get_thing_orientation(self->priv->map, x, y));
 	}
-
-	gtk_widget_queue_draw_area(GTK_WIDGET(arena), 0, 0, arena->priv->width,
-		arena->priv->height);
+      break;
+    default:
+      retval = TILE_WALL;
+      g_warning("ui_arena_get_loc_tile_index: unexpected tile %d", map_get_loc_thing_char(self->priv->map, x, y));
+    }
+  return(retval);
 }
 
-/* note that hook_delete_thing(x,y) is the same as
- * hook_add_thing(x,y,space) */
-void ui_arena_add_thing(UIArena *arena, gint x, gint y, gint thing)
+void
+ui_arena_draw(UIArena *self)
 {
-	gint w_x, w_y;
+  g_return_if_fail(IS_UI_ARENA(self));
 
-	w_x = x * TILE_SIZE;
-	w_y = y * TILE_SIZE;
+  cairo_t *cr = cairo_create(self->priv->surface);
+  cairo_push_group(cr);
+  gint col, row;
 
-	gdk_threads_enter ();
-
-	switch (thing)
+  gint num_cols = map_get_max_x(self->priv->map);
+  gint num_rows = map_get_max_y(self->priv->map);
+  for (row = 0; row < num_rows; row++)
+    {
+      for (col = 0; col < num_cols; col++)
 	{
-	case SPACE:
-		put_tile(arena, arena->priv->space, w_x, w_y);
-		break;
-	case FOOD:
-		put_tile(arena, arena->priv->food, w_x, w_y);
-		break;
-	case PRIZE:
-		put_tile(arena, arena->priv->prize, w_x, w_y);
-		break;
-	case WALL:
-		put_tile(arena, arena->priv->wall, w_x, w_y);
-		break;
-	case BADDIE:
-		put_tile(arena, arena->priv->baddie, w_x, w_y);
-		break;
-	case ROBOT:
-		put_tile(arena, arena->priv->robotDirs[robot->dir], w_x, w_y);
-		break;
-	default:
-		put_tile(arena, arena->priv->wall, w_x, w_y);
-		break;
+	  if(!(0 != g_async_queue_length(self->priv->animation_queue) &&
+	       ROBOT == map_get_loc_thing_char(self->priv->map, col, row)))
+	    ui_arena_draw_tile(cr,
+			       tile_buf[ui_arena_get_loc_tile_index(self, col, row)],
+			       col * TILE_SIZE,
+			       row * TILE_SIZE);
+	  else
+	    ui_arena_draw_tile(cr,
+			       tile_buf[TILE_SPACE],
+			       col * TILE_SIZE,
+			       row * TILE_SIZE);
 	}
-
-	gtk_widget_queue_draw_area(GTK_WIDGET(arena), 0, 0, arena->priv->width,
-		arena->priv->height);
-
-	gdk_threads_leave ();
+    }
+
+  cairo_pop_group_to_source(cr);
+  cairo_paint(cr);
+
+  cairo_rectangle_int_t rect = {0, 0,
+				map_get_max_x(self->priv->map) * TILE_SIZE,
+				map_get_max_y(self->priv->map) * TILE_SIZE};
+  cairo_region_t *crect = cairo_region_create_rectangle(&rect);
+  GdkDrawingContext *gcx = gdk_window_begin_draw_frame(gtk_widget_get_window(GTK_WIDGET(self->priv->arena)), crect);
+  cairo_region_destroy(crect);
+  cairo_t *gcr = gdk_drawing_context_get_cairo_context(gcx);
+  cairo_set_source_surface(gcr, self->priv->surface, 0, 0);
+  cairo_paint(gcr);
+
+  gdk_window_end_draw_frame(gtk_widget_get_window(GTK_WIDGET(self->priv->arena)), gcx);
+  gtk_widget_queue_draw(GTK_WIDGET(self->priv->arena));
 }
 
-void ui_arena_move_robot(UIArena *arena, gint from_x, gint from_y,
-	gint to_x, gint to_y, gint cdir, glong energy, glong score,
-	glong shields)
+static gboolean
+ui_arena_animate(GAsyncQueue *animation_queue)
 {
-	const static gint movement = TILE_SIZE / 16;
-	guint8 distance = dist(from_x, from_y, to_x, to_y);
-	guint w_x = to_x * TILE_SIZE, w_y = to_y * TILE_SIZE, tw_x, tw_y;
-	gboolean ok;
-
-	g_assert(distance <= 1);
-
-	gdk_threads_enter ();
-
-	ui_arena_update_status(arena, "Robot moves..", NULL,
-	                       energy, score, shields);
-
-	/* Check if robot is moving within a single box */
-	if (distance == 0)
-	{
-		put_tile(arena, arena->priv->space, from_x * TILE_SIZE,
-			from_y * TILE_SIZE);
-		put_tile(arena, arena->priv->robotDirs[cdir], to_x * TILE_SIZE,
-			to_y * TILE_SIZE);
-
-		gtk_widget_queue_draw_area(GTK_WIDGET(arena), 0, 0,
-			arena->priv->width,	arena->priv->height);
+  UIArenaAnimate *animation = g_async_queue_pop(animation_queue);
+  if(NULL == animation)
+    return FALSE;
+
+  GtkWidget *arena = GTK_WIDGET(UI_ARENA(animation->arena)->priv->arena);
+
+  cairo_rectangle_int_t rect =
+    {(animation->from_x < animation->to_x ? animation->from_x : animation->to_x),
+     (animation->from_y < animation->to_y ? animation->from_y : animation->to_y),
+     abs(animation->from_x - animation->to_x) + TILE_SIZE,
+     abs(animation->from_y - animation->to_y) + TILE_SIZE};
+  cairo_region_t *crect = cairo_region_create_rectangle(&rect);
+  UIArena *uiarena = UI_ARENA(animation->arena);
+  cairo_t *cr = cairo_create(uiarena->priv->surface);
+
+  cairo_push_group(cr);
+  cairo_rectangle(cr, rect.x, rect.y, rect.width, rect.height);
+  cairo_clip(cr);
+
+  ui_arena_draw_tile
+    (cr,
+     tile_buf[TILE_SPACE],
+     animation->from_x,
+     animation->from_y);
+  ui_arena_draw_tile
+    (cr,
+     tile_buf[animation->tile],
+     animation->from_x + animation->x_delta * (animation->max_iteration - animation->iteration + 1) * animation->movement,
+     animation->from_y + animation->y_delta * (animation->max_iteration - animation->iteration + 1) * animation->movement);
+
+  cairo_pop_group_to_source(cr);
+  cairo_paint(cr);
+
+  GdkDrawingContext *gcx = gdk_window_begin_draw_frame
+    (gtk_widget_get_window(arena), crect);
+  cairo_region_destroy(crect);
+  cairo_t *gcr = gdk_drawing_context_get_cairo_context(gcx);
+  g_assert(NULL != uiarena->priv->surface);
+  cairo_set_source_surface(gcr, uiarena->priv->surface, 0, 0);
+  cairo_paint(gcr);
+
+  gtk_widget_queue_draw_area(arena, rect.x, rect.y, rect.width, rect.height);
+  gdk_window_end_draw_frame(gtk_widget_get_window(arena), gcx);
+  gtk_widget_queue_draw(arena);
+
+  animation->iteration = animation->iteration - 1;
+
+  if(0 == animation->iteration)
+      g_free(animation);
+  else
+      g_async_queue_push_front(animation_queue, animation);
+
+  if(0 == g_async_queue_length(animation_queue))
+    {
+      ui_arena_draw(uiarena);
+      return FALSE;
+    }
+  else
+    return TRUE;
+}
 
-		gdk_threads_leave ();
-		g_usleep(USLEEP_TIME);
-		return;
-	}
+static void
+ui_arena_move_robot(UIArena *self, gint from_x, gint from_y,
+	gint to_x, gint to_y)
+{
+  UIArenaAnimate *animation = g_malloc(sizeof(UIArenaAnimate));
+  animation->arena = self;
+  animation->movement = TILE_SIZE / 8;
+  animation->max_iteration = 8;
+  animation->iteration = 8;
+  animation->tile = TILE_ROBOT;
+  animation->x_delta = 0;
+  animation->y_delta = 0;
+  animation->from_x = from_x * TILE_SIZE;
+  animation->from_y = from_y * TILE_SIZE;
+  animation->to_x = to_x * TILE_SIZE;
+  animation->to_y = to_y * TILE_SIZE;
+  if(from_y - to_y > 0 && from_x - to_x == 0)
+    {
+      animation->y_delta = -1;
+      animation->tile = TILE_ROBOT_NORTH;
+    }
+  else if(from_y - to_y < 0 && from_x - to_x == 0)
+    {
+      animation->y_delta = 1;
+      animation->tile = TILE_ROBOT_SOUTH;
+    }
+  else if(from_y - to_y == 0 && from_x - to_x < 0)
+    {
+      animation->x_delta = 1;
+      animation->tile = TILE_ROBOT_EAST;
+    }
+  else if(from_y - to_y == 0 && from_x - to_x > 0)
+    {
+      animation->x_delta = -1;
+      animation->tile = TILE_ROBOT_WEST;
+    }
+  else if(from_y == to_y && from_x == to_x)
+    {
+      g_debug("ui_arena_move_robot: Called but no move requested (%d, %d)->(%d, %d).",
+	      from_x, from_y, to_x, to_y);
+    }
+  else
+    {
+      animation->tile = TILE_ROBOT;
+      g_warning("ui_arena_move_robot: Weird unknown robot direction (%d, %d)->(%d, %d). I'm Confused.",
+		from_x, from_y, to_x, to_y);
+    }
+
+  if(0 == g_async_queue_length(self->priv->animation_queue))
+    {
+      g_async_queue_push(self->priv->animation_queue, animation);
+      gdk_threads_add_timeout(SLEEP_TIME/8, G_SOURCE_FUNC(ui_arena_animate), self->priv->animation_queue);
+      
+    }
+  else
+    { /* Entries in the queue mean that there should already be an
+	 animation timeout running */
+      g_async_queue_push(self->priv->animation_queue, animation);
+    }
+}
 
-	from_x *= TILE_SIZE;
-	from_y *= TILE_SIZE;
-	tw_y = w_y;
-	tw_x = w_x;
-	switch (cdir)
-	{
-	case NORTH:
-		tw_y = from_y - movement;
-		break;
-	case SOUTH:
-		tw_y = from_y + movement;
-		break;
-	case EAST:
-		tw_x = from_x + movement;
-		break;
-	case WEST:
-		tw_x = from_x - movement;
-		break;
-	default:
-		g_printf("Weird unknown robot direction. I'm Confused.\n");
-	}
+void
+ui_arena_move_robot_marshal(gpointer data_wrapper[])
+{
+  MapMove *move = data_wrapper[1];
+  ui_arena_move_robot(data_wrapper[0],
+		      move->origin_x,
+		      move->origin_y,
+		      move->dest_x,
+		      move->dest_y);
+
+  g_free(move);
+  g_free(data_wrapper);
+}
 
+static void
+ui_arena_on_map_move(Map *map, gpointer param, gpointer data)
+{
+  g_return_if_fail(IS_UI_ARENA(data));
 
-	while (1)
-	{
-		put_tile(arena, arena->priv->space, from_x, from_y);
-		put_tile(arena, arena->priv->robotDirs[cdir], tw_x, tw_y);
-
-		ok = FALSE;
-		if (tw_x < w_x)
-		{
-			tw_x += movement;
-			ok = TRUE;
-		}
-		else if (tw_x > w_x)
-		{
-			tw_x -= movement;
-			ok = TRUE;
-		}
-		if (tw_y < w_y)
-		{
-			tw_y += movement;
-			ok = TRUE;
-		}
-		else if (tw_y > w_y)
-		{
-			tw_y -= movement;
-			ok = TRUE;
-		}
-
-		gtk_widget_queue_draw_area(GTK_WIDGET(arena), 0, 0,
-			arena->priv->width,	arena->priv->height);
-		gdk_window_process_all_updates();
-
-		gdk_threads_leave ();
-		g_usleep(USLEEP_TIME / 16);
-		gdk_threads_enter ();
-
-		if (!ok)
-			break;
-	}
+  gpointer* data_wrapper;
+  data_wrapper = g_malloc(sizeof(gpointer) * 2);
+  data_wrapper[0] = data;
+  data_wrapper[1] = g_memdup(param, sizeof(MapMove));
 
-	gdk_threads_leave ();
-	g_usleep(USLEEP_TIME);
+  gdk_threads_add_idle(G_SOURCE_FUNC(ui_arena_move_robot_marshal), data_wrapper);
 }
 
-/* hooks to animate the robot */
-void ui_arena_robot_smell(UIArena *arena, gint x, gint y, gint cdir,
-	glong energy, glong score, glong shields, const gchar *thing)
+static void
+ui_arena_map_filename_update(UIArena *self)
 {
-	gdk_threads_enter ();
-	/* If we want to change the pic, do it here */
-	ui_arena_update_status(arena, "Robot sniffs for %s...", thing,
-		energy, score, shields);
-	gdk_threads_leave ();
+  gchar* mapfile = map_get_filename(self->priv->map);
 
-	g_usleep(USLEEP_TIME);
-}
+  gtk_label_set_text(self->priv->filelabel,
+		     NULL != mapfile ? mapfile : "No map loaded.");
 
-void ui_arena_robot_zap(UIArena *arena,	gint x,	gint y,	gint cdir,
-	gint x_to, gint y_to, glong energy, glong score, glong shields)
-{
-	gdk_threads_enter ();
-	ui_arena_update_status(arena, "Robot fires his little gun...", NULL,
-		energy, score, shields);
-	gdk_threads_leave ();
+  gtk_widget_queue_draw(GTK_WIDGET(self->priv->filelabel));
 
-	g_usleep(USLEEP_TIME);
+  g_free(mapfile);
 }
 
-void ui_arena_robot_feel(UIArena *arena,
-	gint x, gint y, gint cdir,
-	gint x_to, gint y_to, glong energy, glong score, glong shields,
-	const gchar *thing)
+static void
+ui_arena_on_map_update(Map *map, gpointer data)
 {
-	gdk_threads_enter ();
-	ui_arena_update_status(arena, "Robot feels for %s...", thing,
-		energy, score, shields);
-	gdk_threads_leave ();
+  g_return_if_fail(IS_UI_ARENA(data));
 
-	g_usleep(USLEEP_TIME);
+  gdk_threads_add_idle(G_SOURCE_FUNC(ui_arena_draw), data);
+  gdk_threads_add_idle(G_SOURCE_FUNC(ui_arena_map_filename_update), data);
 }
 
-void ui_arena_robot_grab(UIArena *arena, gint x, gint y, gint cdir,
-	gint x_to, gint y_to, glong energy, glong score, glong shields)
+void
+ui_arena_set_map(UIArena *arena, Map *map)
 {
-	gdk_threads_enter ();
-	ui_arena_update_status(arena, "Robot grabs...", NULL,
-		energy, score, shields);
-	gdk_threads_leave ();
-
-	g_usleep(USLEEP_TIME);
+  g_return_if_fail(IS_UI_ARENA(arena));
+  g_return_if_fail(G_IS_MAP(map));
+
+  arena->priv->map = map;
+  gint num_cols = map_get_max_x(arena->priv->map);
+  gint num_rows = map_get_max_y(arena->priv->map);
+  arena->priv->width = num_cols * TILE_SIZE;
+  arena->priv->height = num_rows * TILE_SIZE + 32;
+  ui_arena_map_filename_update(arena);
+
+  gtk_widget_set_size_request(GTK_WIDGET(arena), arena->priv->width,
+			      arena->priv->height);
+  arena->priv->connected_signals[MAP_UPDATE] = g_signal_connect(map, "map-update", G_CALLBACK(ui_arena_on_map_update), arena);
+  arena->priv->connected_signals[MAP_MOVE] = g_signal_connect(map, "map-move",   G_CALLBACK(ui_arena_on_map_move), arena);
+  ui_arena_draw(arena);
 }
 
-void ui_arena_robot_look(UIArena *arena, gint x, gint y, gint cdir,
-	gint x_to, gint y_to, glong energy, glong score, glong shields,
-	const gchar *thing)
+GtkWidget *
+ui_arena_new(Map *map)
 {
-	gdk_threads_enter ();
-	ui_arena_update_status(arena, "Robot looks for %s...", thing,
-		energy, score, shields);
-	gdk_threads_leave ();
+  UIArena* arena = UI_ARENA(g_object_new(UI_TYPE_ARENA, NULL));
+
+  if(NULL != map)
+    {
+      g_return_val_if_fail(G_IS_MAP(map), NULL);
+      ui_arena_set_map(arena, map);
+    }
 
-	g_usleep(USLEEP_TIME);
+  return GTK_WIDGET(arena);
 }
diff --git a/src/ui-cmdwin.c b/src/ui-cmdwin.c
index f663aa1..6728af4 100644
--- a/src/ui-cmdwin.c
+++ b/src/ui-cmdwin.c
@@ -28,21 +28,23 @@ struct _UICmdWinPrivate
 	GtkWidget *vte;
 };
 
-#define UI_CMDWIN_GET_PRIVATE(obj) \
-    G_TYPE_INSTANCE_GET_PRIVATE(obj, UI_TYPE_CMDWIN, UICmdWinPrivate)
-
-G_DEFINE_TYPE(UICmdWin, ui_cmdwin, GTK_TYPE_VBOX)
+G_DEFINE_TYPE_WITH_CODE(UICmdWin, ui_cmdwin, GTK_TYPE_BOX, G_ADD_PRIVATE(UICmdWin))
 
 GtkWidget *ui_cmdwin_new(void)
 {
-	return GTK_WIDGET(g_object_new(UI_TYPE_CMDWIN, NULL));
+  UICmdWin *self = g_object_new(UI_TYPE_CMDWIN, NULL);
+
+  return GTK_WIDGET(self);
 }
 
 static void ui_cmdwin_init(UICmdWin *cmdwin)
 {
+	gtk_orientable_set_orientation(GTK_ORIENTABLE(cmdwin),
+				       GTK_ORIENTATION_VERTICAL);
+
 	int master_pty, slave_pty;
 
-	cmdwin->priv = UI_CMDWIN_GET_PRIVATE(cmdwin);
+	cmdwin->priv = ui_cmdwin_get_instance_private(cmdwin);
 
 	cmdwin->priv->vte = vte_terminal_new();
 
@@ -64,13 +66,13 @@ static void ui_cmdwin_init(UICmdWin *cmdwin)
 	fflush (stdout); setlinebuf (stdout);
 	fflush (stderr); setlinebuf (stderr);
 
-	vte_terminal_set_pty(VTE_TERMINAL(cmdwin->priv->vte), master_pty);
+	VtePty *fpty = vte_pty_new_foreign_sync(master_pty, NULL, NULL);
+
+	vte_terminal_set_pty(VTE_TERMINAL(cmdwin->priv->vte), fpty);
 
 	gtk_widget_show(cmdwin->priv->vte);
 }
 
 static void ui_cmdwin_class_init(UICmdWinClass *klass)
 {
-	g_type_class_add_private(G_OBJECT_CLASS(klass),
-		sizeof(UICmdWinPrivate));
 }
